---
title: PublicKeyCredentialCreationOptions.pubKeyCredParams
slug: Web/API/PublicKeyCredentialCreationOptions/pubKeyCredParams
tags:
  - API
  - Property
  - PublicKeyCredentialCreationOptions
  - Reference
  - Web Authentication API
  - WebAuthn
---
<p>{{APIRef("Web Authentication API")}}{{securecontext_header}}</p>

<p>The <strong><code>pubKeyCredParams</code></strong> property of the {{domxref("PublicKeyCredentialCreationOptions")}} dictionary is an {{jsxref("Array")}} whose elements are objects describing the desired features of the credential to be created. These objects define the type of public-key and the algorithm used for <a href="https://en.wikipedia.org/wiki/Digital_signature">cryptographic signature</a> operations.</p>

<p>If this array contains multiple elements, they are sorted by descending order of preference.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>pubKeyCredParams </em>= <em>publicKeyCredentialCreationOptions</em>.pubKeyCredParams</pre>

<h3 id="Value">Value</h3>

<p>An {{jsxref("Array")}} whose elements are objects with the following properties:</p>

<dl>
 <dt><code>type</code></dt>
 <dd>A string describing type of public-key credential to be created. As of this writing (March 2019), only <code>"public-key"</code> may be used.</dd>
 <dt><code>alg</code></dt>
 <dd>A numeric identifier for the algorithm to be used to generate the key pair. The links between identifier and algorithms are defined in <a href="https://www.iana.org/assignments/cose/cose.xhtml#algorithms">this IANA registry</a> (e.g. <code>-7</code> indicates the elliptic curve algorithm ECDSA with SHA-256).</dd>
</dl>

<p>Though those elements are sorted by preference (the first element being the most prefered), it is up to the client to choose among those elements for building the credential.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var publicKey = {
  pubKeyCredParams: [
    // We would like an elliptic curve to be used if possible
    {
      type: "public-key",
      alg: -7
    },
    // If not, then we will fallback on an RSA algorithm
    {
      type: "public-key",
      alg: -37
    }
  ],
  challenge: new Uint8Array(26) /* this actually is given from the server */,
  rp: {
    name: "Example CORP",
    id  : "login.example.com"
  },
  user: {
    id: new Uint8Array(26), /* To be changed for each user */
    name: "jdoe@example.com",
    displayName: "John Doe",
  }
};

navigator.credentials.create({ publicKey })
  .then(function (newCredentialInfo) {
    // send attestation response and client extensions
    // to the server to proceed with the registration
    // of the credential
  }).catch(function (err) {
     console.error(err);
  });</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebAuthn','#dom-publickeycredentialcreationoptions-pubkeycredparams','pubKeyCredParams')}}</td>
   <td>{{Spec2('WebAuthn')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PublicKeyCredentialCreationOptions.pubKeyCredParams")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.iana.org/assignments/cose/cose.xhtml#algorithms">The IANA COSE Algorithms registry</a> which describes the cryptographic algorithms and their corresponding identifier (used as the <code>"alg"</code> key here)</li>
</ul>
